-- LUALOCALS < ---------------------------------------------------------
local math, minetest
	= math, minetest
local math_ceil
	= math.ceil
-- LUALOCALS > ---------------------------------------------------------

local schemkeys = {
	["."] = {name = "air", prob = 0},
	["#"] = {name = "world:black"},
	["*"] = {name = "air"},
	r = {name = "buildings:red"},
	g = {name = "buildings:green"},
	b = {name = "buildings:blue"},
	y = {name = "buildings:yellow"},
	p = {name = "buildings:purple"},
	k = {name = "buildings:black"},

}

ch_schematics.altars = {}
ch_schematics.altar_defs = {}
ch_schematics.altar_cores = {}

local clear9 = {
	"*********",
	"*********",
	"*********",
	"*********",
	"*********",
	"*********",
	"*********",
	"*********",
	"*********",
}
local altar1, size1, def1 = ch_schematics.ezschematic(schemkeys,
	{
		{
			"yyyyyyyyy",
			"ygggggggy",
			"ygk#k#kgy",
			"yg#yyy#gy",
			"ygky#ykgy",
			"yg#yyy#gy",
			"ygk#k#kgy",
			"ygggggggy",
			"yyyyyyyyy",
		},
		{
			"*********",
			"*********",
			"***r*r***",
			"**r***r**",
			"****r****",
			"**r***r**",
			"***r*r***",
			"*********",
			"*********",
		},
		{
			"*********",
			"*********",
			"***g*g***",
			"**g***g**",
			"****r****",
			"**g***g**",
			"***g*g***",
			"*********",
			"*********",
		},
		{
			"*********",
			"*********",
			"*********",
			"*********",
			"****r****",
			"*********",
			"*********",
			"*********",
			"*********",
		},
		{
			"*********",
			"*********",
			"*********",
			"*********",
			"****g****",
			"*********",
			"*********",
			"*********",
			"*********",
		},
		clear9, clear9, clear9, clear9,
		clear9, clear9, clear9, clear9,
		clear9, clear9, clear9, clear9,
	})
ch_schematics.altars[#ch_schematics.altars + 1] = {schem = altar1, size = size1}
ch_schematics.altar_defs[#ch_schematics.altar_defs + 1] = def1
ch_schematics.altar_cores[#ch_schematics.altar_cores + 1] = {x=4, y=4, z=4}

local altar2, size2, def2 = ch_schematics.ezschematic(schemkeys,
	{
		{
			"yyyyyyyyy",
			"y#kr#rk#y",
			"ykrkrkrky",
			"yrkryrkry",
			"y#ry#yr#y",
			"yrkryrkry",
			"ykrkrkrky",
			"y#kr#rk#y",
			"yyyyyyyyy",
		},
		{
			"*********",
			"*b**b**b*",
			"*********",
			"*********",
			"*b**b**b*",
			"*********",
			"*********",
			"*b**b**b*",
			"*********",
		},
		{
			"*********",
			"*g**g**g*",
			"*********",
			"*********",
			"*g**b**g*",
			"*********",
			"*********",
			"*g**g**g*",
			"*********",
		},
		{
			"*********",
			"*********",
			"*********",
			"*********",
			"****b****",
			"*********",
			"*********",
			"*********",
			"*********",
		},
		{
			"*********",
			"*********",
			"*********",
			"*********",
			"****g****",
			"*********",
			"*********",
			"*********",
			"*********",
		},
		clear9, clear9, clear9, clear9,
		clear9, clear9, clear9, clear9,
		clear9, clear9, clear9, clear9,
	})
ch_schematics.altars[#ch_schematics.altars + 1] = {schem = altar2, size = size2}
ch_schematics.altar_defs[#ch_schematics.altar_defs + 1] = def2
ch_schematics.altar_cores[#ch_schematics.altar_cores + 1] = {x=4, y=4, z=4}

local clear15 = {
	"***************",
	"***************",
	"***************",
	"***************",
	"***************",
	"***************",
	"***************",
	"***************",
	"***************",
	"***************",
	"***************",
	"***************",
	"***************",
	"***************",
	"***************",
}

local altar3, size3, def3 = ch_schematics.ezschematic(schemkeys,
	{
		{
			"yyyyyyyyyyyyyyy",
			"y##k##kyk##k##y",
			"y#bbbbbybbbbb#y",
			"ykb###kyk###bky",
			"y#b#bykykyb#b#y",
			"y#b#y#kyk#y#b#y",
			"ykbkkkkykkkkbky",
			"yyyyyyy#yyyyyyy",
			"ykbkkkkykkkkbky",
			"y#b#y#kyk#y#b#y",
			"y#b#bykykyb#b#y",
			"ykb###kyk###bky",
			"y#bbbbbybbbbb#y",
			"y##k##kyk##k##y",
			"yyyyyyyyyyyyyyy",
		},
		{
			"***************",
			"*kk*kk***kk*kk*",
			"*k***********k*",
			"***kkk***kkk***",
			"*k*k*******k*k*",
			"*k*k*k***k*k*k*",
			"***************",
			"*******b*******",
			"***************",
			"*k*k*k***k*k*k*",
			"*k*k*******k*k*",
			"***kkk***kkk***",
			"*k***********k*",
			"*kk*kk***kk*kk*",
			"***************",
		},
		{
			"***************",
			"*kk*kk***kk*kk*",
			"*k***********k*",
			"***kkk***kkk***",
			"*k*k*******k*k*",
			"*k*k*k***k*k*k*",
			"***************",
			"*******b*******",
			"***************",
			"*k*k*k***k*k*k*",
			"*k*k*******k*k*",
			"***kkk***kkk***",
			"*k***********k*",
			"*kk*kk***kk*kk*",
			"***************",
		},
		{
			"***************",
			"***************",
			"***************",
			"***************",
			"***************",
			"*****k***k*****",
			"***************",
			"*******p*******",
			"***************",
			"*****k***k*****",
			"***************",
			"***************",
			"***************",
			"***************",
			"***************",
		},
		{
			"***************",
			"***************",
			"***************",
			"***************",
			"***************",
			"*****p***p*****",
			"***************",
			"*******p*******",
			"***************",
			"*****p***p*****",
			"***************",
			"***************",
			"***************",
			"***************",
			"***************",
		},
		{
			"***************",
			"***************",
			"***************",
			"***************",
			"***************",
			"***************",
			"***************",
			"*******g*******",
			"***************",
			"***************",
			"***************",
			"***************",
			"***************",
			"***************",
			"***************",
		},
		clear15, clear15, clear15, clear15,
		clear15, clear15, clear15, clear15,
		clear15, clear15, clear15, clear15,
	})
ch_schematics.altars[#ch_schematics.altars + 1] = {schem = altar3, size = size3}
ch_schematics.altar_defs[#ch_schematics.altar_defs + 1] = def3
ch_schematics.altar_cores[#ch_schematics.altar_cores + 1] = {x=7, y=5, z=7}

