
local schemkeys = {
	["."] = {name = "air", prob = 0},
	["#"] = {name = "world:blacka"},
	["o"] = {name = "world:yellow"},
	["+"] = {name = "world:blue"},
	["*"] = {name = "air"},
	r = {name = "buildings:red"},
	g = {name = "buildings:green"},
	b = {name = "buildings:blue"},
	y = {name = "buildings:yellow"},
	p = {name = "buildings:purple"},
	k = {name = "buildings:black"},

}

ch_schematics.rooms = {}
ch_schematics.room_defs = {}
ch_schematics.room_cores = {}

local clear15 = {
	"***************",
	"***************",
	"***************",
	"***************",
	"***************",
	"***************",
	"***************",
	"***************",
	"***************",
	"***************",
	"***************",
	"***************",
	"***************",
	"***************",
	"***************",
}


local storage_room, storage_room_size, storage_room_def = ch_schematics.ezschematic(schemkeys,
	{
		{
			"###############",
			"###############",
			"##ooooooooooo##",
			"##o#########o##",
			"##o#########o##",
			"##o##ooooo##o##",
			"##o##o#b#o##o##",
			"##o##obgbo##o##",
			"##o##o#b#o##o##",
			"##o##ooooo##o##",
			"##o#########o##",
			"##o#########o##",
			"##ooooooooooo##",
			"###############",
			"###############",
		},
		clear15, clear15, clear15, clear15,
		clear15, clear15, clear15, clear15,
		clear15, clear15, clear15, clear15,
		clear15, clear15,
	})
ch_schematics.rooms[#ch_schematics.rooms + 1] = {schem = storage_room, size = storage_room_size}
ch_schematics.room_defs[#ch_schematics.room_defs + 1] = storage_room_def
ch_schematics.room_cores[#ch_schematics.room_cores + 1] = {x=7, y=0, z=7}


local dark_room, dark_room_size, dark_room_def = ch_schematics.ezschematic(schemkeys,
	{
		{
			"###############",
			"###############",
			"###############",
			"###############",
			"###############",
			"###############",
			"###############",
			"###############",
			"###############",
			"###############",
			"###############",
			"###############",
			"###############",
			"###############",
			"###############",
		},
		clear15, clear15, clear15, clear15,
		clear15, clear15, clear15, clear15,
		clear15, clear15, clear15, clear15,
		clear15, clear15,
	})
ch_schematics.rooms[#ch_schematics.rooms + 1] = {schem = dark_room, size = dark_room_size}
ch_schematics.room_defs[#ch_schematics.room_defs + 1] = dark_room_def
ch_schematics.room_cores[#ch_schematics.room_cores + 1] = {x=7, y=0, z=7}


local access_room, access_room_size, access_room_def = ch_schematics.ezschematic(schemkeys,
	{
		{
			"###############",
			"###############",
			"##ooooooooooo##",
			"##o#########o##",
			"##o#########o##",
			"##o##ooooo##o##",
			"##o##o###o##o##",
			"##o##o###o##o##",
			"##o##o###o##o##",
			"##o##ooooo##o##",
			"##o#########o##",
			"##o#########o##",
			"##ooooooooooo##",
			"###############",
			"###############",
		},
		clear15, clear15, clear15, clear15,
		clear15, clear15, clear15, clear15,
		clear15, clear15, clear15, clear15,
		clear15, clear15,
	})
ch_schematics.rooms[#ch_schematics.rooms + 1] = {schem = access_room, size = access_room_size}
ch_schematics.room_defs[#ch_schematics.room_defs + 1] = access_room_def
ch_schematics.room_cores[#ch_schematics.room_cores + 1] = {x=7, y=0, z=7}


local clear_royal = {
	"*******************",
	"*******************",
	"*******************",
	"*******************",
	"*******************",
	"*******************",
	"*******************",
	"*******************",
	"*******************",
	"*******************",
	"*******************",
	"*******************",
	"*******************",
	"*******************",
	"*******************",
	"*******************",
	"*******************",
	"*******************",
	"*******************",
}


local royal_room, royal_room_size, royal_room_def = ch_schematics.ezschematic(schemkeys,
	{
		{
			"###################",
			"###################",
			"###################",
			"#########+#########",
			"########+g+########",
			"#########+#########",
			"######+#####+######",
			"#####+g+###+g+#####",
			"######+#####+######",
			"#########+#########",
			"########+g+########",
			"#########+#########",
			"###################",
			"###################",
			"###################",
			"###################",
			"###################",
			"###################",
			"###################",
		},
		{
			"#########o#########",
			"########o#o########",
			"#######o#+#o#######",
			"######o#+++#o######",
			"#####o#+++++#o#####",
			"####o#+++++++#o####",
			"###o#+++++++++#o###",
			"##o#+++++++++++#o##",
			"###o#+++++++++#o###",
			"####o#+++++++#o####",
			"#####o#+++++#o#####",
			"######o#+++#o######",
			"#######o#+#o#######",
			"########o#o########",
			"#########o#########",
			"###################",
			"#########b#########",
			"########bgb########",
			"#########b#########",
		},
		clear_royal, clear_royal, clear_royal, clear_royal,
		clear_royal, clear_royal, clear_royal, clear_royal,
		clear_royal, clear_royal, clear_royal, clear_royal,
		clear_royal, clear_royal, clear_royal,
	})
ch_schematics.rooms[#ch_schematics.rooms + 1] = {schem = royal_room, size = royal_room_size}
ch_schematics.room_defs[#ch_schematics.room_defs + 1] = royal_room_def
ch_schematics.room_cores[#ch_schematics.room_cores + 1] = {x=9, y=0, z=7}
